/*
 * exempi - xmppacket.cpp
 *
 * Copyright (C) 2007 Hubert Figuiere
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, 
 * USA
 */

#include <iostream>

#include "xmploader.h"
#include "xmppacket.h"
#include "xmptree.h"

namespace Exempi {

	struct XmpPacket::Private
	{
		Private()
			: is_valid(false),
				tree()
			{
			}
		bool is_valid;
		XmpTree tree;
	};

	
	XmpPacket::XmpPacket(XmpLoader *loader)
		: d(new Private())
	{
		d->is_valid = d->tree.parse(loader);
	}


	XmpPacket::~XmpPacket()
	{
		delete d;
	}
	

	bool XmpPacket::isValid()
	{
		return d->is_valid;
	}


	XmpTree & XmpPacket::tree()
	{
		return d->tree;
	}

	

}
