/*
 * exempi - xmptree.h
 *
 * Copyright (C) 2007 Hubert Figuiere
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, 
 * USA
 */


#ifndef __EXEMPI_XMPVALUE_H_
#define __EXEMPI_XMPVALUE_H_

#include <string>
#include <map>
#include <set>
#include <vector>

#include <boost/any.hpp>

namespace Exempi {

	/** An XMP Value */
	struct XmpValue
	{
		XmpValue()
			: type(XMP_VALUE_TYPE_NONE)
			{
			}

		enum {
			XMP_VALUE_TYPE_NONE = 0,
			XMP_VALUE_TYPE_SINGLE,
			XMP_VALUE_TYPE_RESOURCE,
			XMP_VALUE_TYPE_BAG,
			XMP_VALUE_TYPE_SEQ,
			XMP_VALUE_TYPE_ALT,
			XMP_VALUE_TYPE_STRUCTURE
		};
		typedef std::set<std::string> Bag;
		typedef std::vector<std::string> Seq;
		typedef std::map<std::string, std::string> Alt;
		typedef std::map<std::string, std::string> Structure;
		typedef std::map<std::string, std::string> Resource;
		typedef std::string Single;
		int type;
		boost::any value;
	};

}

#endif
